#ifndef __DS18B20_H__
#define __DS18B20_H__

#include "ets_sys.h"
#include "osapi.h"
#include "gpio.h"

#define DSvorl_MUX		PERIPHS_IO_MUX_GPIO2_U
#define DSvorl_FUNC		FUNC_GPIO2
#define DSvorl_PIN		2

#define DSback_MUX		PERIPHS_IO_MUX_GPIO4_U
#define DSback_FUNC		FUNC_GPIO4
#define DSback_PIN		4



#define DS1820_WRITE_SCRATCHPAD 	0x4E
#define DS1820_READ_SCRATCHPAD      0xBE
#define DS1820_COPY_SCRATCHPAD 		0x48
#define DS1820_READ_EEPROM 			0xB8
#define DS1820_READ_PWRSUPPLY 		0xB4
#define DS1820_SEARCHROM 			0xF0
#define DS1820_SKIP_ROM             0xCC
#define DS1820_READROM 				0x33
#define DS1820_MATCHROM 			0x55
#define DS1820_ALARMSEARCH 			0xEC
#define DS1820_CONVERT_T            0x44

static uint16_t oddparity[16] = {0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0};

//void ds_init();

void ICACHE_FLASH_ATTR DS_Gpio();
uint8_t ICACHE_FLASH_ATTR DS_reset(uint8_t gpio_pin);
void ICACHE_FLASH_ATTR DS_write(uint8_t v, int power, uint8_t gpio_pin);
void ICACHE_FLASH_ATTR DS_write_bit(int v, uint8_t gpio_pin);
uint8_t ICACHE_FLASH_ATTR DS_read(uint8_t gpio_pin);
int ICACHE_FLASH_ATTR DS_read_bit(uint8_t gpio_pin);

#endif
